using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_CRM._0_Modelos;
using Exferia_CRM._3_Vistas.Controladoras;
using Exferia_CRM.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_CRM._3_Vistas
{
    public partial class P_TrabajosRealizados_Historico : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_TrabajosRealizados_Historico_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador...............................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private Timer g_timer_Paginar = new Timer();
        #endregion

        #region Objetos en pantalla
        //Exferia_Label
        internal Exferia_Label Exferia_Label_HoraInicio { get { return ex_lbl_P_TrabajosRealizados_HoraInicio; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_ClientesPotenciales { get { return ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial; } }
        internal Exferia_F3 Exferia_F3_MotivosNoVisita { get { return ex_usc_F3_P_TrabajosRealizados_Historio_MotivoNoVisita; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_TrabajoRealizados { get { return ex_txt_P_TrabajosRealizados_Historico_TrabajoRealizado; } }
        internal Exferia_TextBox Exferia_TextBox_Horas { get { return ex_txt_P_TrabajosRealizados_Historicos_Horas; } }
        internal Exferia_TextBox Exferia_TextBox_Minutos { get { return ex_txt_P_TrabajosRealizados_Historicos_Minutos; } }

        //Exferia_TextBox_ConMascara
        internal Exferia_TextBox_ConMascara Exferia_TextBox_Mascara_HoraInicio { get { return ex_txt_P_TrabajosRealizados_Historicos_HoraInicio; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_TrabajosRealizados_Historico { get { return ex_usc_Paginador; } }

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Fecha { get { return ex_usc_P_TrabajosRealizados_Historico_FechaInicio; } }
        #endregion

        public P_TrabajosRealizados_Historico(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, List<INTERNO_Permisos_Modelo> _lst_INTERNO_Permisos_Modelo, string _str_Opcion , Dictionary<string,long?> _dct_idRelacionados, string _str_GUID)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            //CheckForIllegalCrossThreadCalls = false;

            //Datos de Opciones detalle
            g_mdl_PRV_OpcionesDetalle = Datos_Generales.PRV_Opciones_Buscar_Detalles(_str_Opcion);

            //Buscar Permisos
            g_lst_INTERNO_Permisos_Modelo = _lst_INTERNO_Permisos_Modelo;

            //Instancias Controladora
            g_obj_Controladora = new P_TrabajosRealizados_Historico_Controladora(this);

            g_obj_Controladora.g_str_GUID = _str_GUID;
            g_obj_Controladora.g_lng_idEmpleado = _dct_idRelacionados.Where(m => m.Key.Equals(nameof(INTERNO_CRMH_TrabajosRealizados_Listado_Modelo.idEmpleado))).FirstOrDefault().Value.Value;
            //Terminal
            KeyValuePair<string, long?> kvp_Terminal= _dct_idRelacionados.Where(m => m.Key.Equals(nameof(INTERNO_CRMH_TrabajosRealizados_Listado_Modelo.idTerminal))).FirstOrDefault();
            if (kvp_Terminal.Value != null)
            {
                g_obj_Controladora.g_lng_idTerminal = kvp_Terminal.Value;
            }
           
            //################################################
            //################################################

            //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
            ex_btn_P_TrabajosRealizados_Historico_Borrar.Exferia_Button_Bloqueable = false;
            ex_btn_P_TrabajosRealizados_Historico_Grabar.Exferia_Button_Bloqueable = false;

            //Mirar si hay que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);
            }

            //Titulo de la Pantalla ...........................................................
            P_Base_TituloPantalla = g_mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

            try
            {
                //Empresa seleccionada y fecha de trabajo ..........................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;
                //Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                    "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Terminales) + "/" + nameof(P_Terminales));
                    }
                }

                //Bloquear pantalla hasta que termine la carga por defecto .....................
                Enabled = false;
                //..............................................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Fecha y hora de Inicio por Defecto
                ex_usc_P_TrabajosRealizados_Historico_FechaInicio.Exferia_FechaSeleccion_Fecha = DateTime.Now.ToString("dd/MM/yyyy");
                ex_txt_P_TrabajosRealizados_Historicos_HoraInicio.Text = DateTime.Now.ToString("HH:mm");

                //Rellenar el F3 de Cliente Potencial
                ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_CRM_CLIENTESPOTENCIAL;
                ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Exferia_F3_PRINCIPAL_Obligatorio = true;

                //Rellenar el F3 de MotivoNoVisita
                ex_usc_F3_P_TrabajosRealizados_Historio_MotivoNoVisita.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_CRM_MOTIVONOVISITA;
                ex_usc_F3_P_TrabajosRealizados_Historio_MotivoNoVisita.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_TrabajosRealizados_Historio_MotivoNoVisita.Exferia_F3_PRINCIPAL_Obligatorio = false;

            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico) + "/" + nameof(P_TrabajosRealizados_Historico));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto.....
                Enabled = true;
                //.............................................................
            }
        }

        #region Inicio de Pantalla
        private void P_TrabajosRealizados_Historico_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico) + "/" + nameof(P_TrabajosRealizados_Historico_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_TrabajosRealizados_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    if (P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + "- Añadir";

                        ActivarBotones(false);

                        //Se Cambia el valor de la variable para queno salte el evento en el otro lado de que se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Foco_Codigo();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Text = P_Base_Campo_2;
                            }
                        }
                        else
                        {
                            ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Foco_Codigo();
                        }
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                    }
                    //Modificar
                    else
                    {
                        //Comprobamos cual es su padre, si es ClientePotencial ocultamos los botones de borrar y grabar
                        if (P_Base_PantallaOrigen.Name.Equals(nameof(P_ClientesPotenciales)))
                        {
                            //De momento en clientePotencial solo se usa para ver los datos, asi que bloqueamos los controles
                            ex_btn_P_TrabajosRealizados_Historico_Borrar.Visible = false;
                            ex_btn_P_TrabajosRealizados_Historico_Grabar.Visible = false;
                            ex_usc_F3_P_TrabajosRealizados_Historio_ClientePotencial.Enabled = false;
                            ex_usc_F3_P_TrabajosRealizados_Historio_MotivoNoVisita.Enabled = false;
                            ex_txt_P_TrabajosRealizados_Historicos_HoraInicio.Enabled = false;
                            ex_txt_P_TrabajosRealizados_Historicos_Horas.Enabled = false;
                            ex_txt_P_TrabajosRealizados_Historicos_Minutos.Enabled = false;
                            ex_txt_P_TrabajosRealizados_Historico_TrabajoRealizado.Enabled = false;
                            ex_usc_P_TrabajosRealizados_Historico_FechaInicio.Enabled = false;
                        }
                        
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_TrabajosRealizados_Historico.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_TrabajosRealizados_Historico.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Terminales) + "/" + nameof(P_TrabajosRealizados_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        private void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_TrabajosRealizados_Historico.Visible)
            {
                Exferia_Paginador_TrabajosRealizados_Historico.Visible = _bol_Activar;
            }

            if (ex_btn_P_TrabajosRealizados_Historico_Borrar.Enabled)
            {
                ex_btn_P_TrabajosRealizados_Historico_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar
        private void ex_btn_P_TrabajosRealizados_Historico_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_TrabajosRealizados_Historico_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
             if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }
        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TrabajosRealizados_Historico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TrabajosRealizados_Historico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();
                    
                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TrabajosRealizados_Historico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();
                    
                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TrabajosRealizados_Historico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();
                    
                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;
                    
                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_TrabajosRealizados_Historico.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_TrabajosRealizados_Historico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void ex_usc_F3_P_Terminales_Exferia_F3_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion
    }
}
